// background.js

chrome.runtime.onStartup.addListener( () => {
    console.log(onStartup());
});
// Listen for button click event from popup
chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.type === 'buttonClick') {
    // Send message to the content script for data extraction
    chrome.tabs.query({ active: true, currentWindow: true }, (tabs) => {
      const tab = tabs[0];

      // chrome.scripting.executeScript({
      //   target: { tabId: tab.id },
      //   files: ['extractData.js']
      // });
      console.log("buttonClick"); 
      chrome.tabs.sendMessage(tab.id, { type: 'extractData', data: message.data });   
    });
  }
});
chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.type === 'buttonClick_sbm') {
    // Send message to the content script for data extraction
    chrome.tabs.query({ active: true, currentWindow: true }, (tabs) => {
      const tab = tabs[0];

      // chrome.scripting.executeScript({
      //   target: { tabId: tab.id },
      //   files: ['extractData.js']
      // });
      console.log("buttonClick sbm inside"); 
      chrome.tabs.sendMessage(tab.id, { type: 'data_pmfs_extract', data: message.data });   
    });
  }
});
chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.type === 'buttonClick_egram') {
    // Send message to the content script for data extraction
    chrome.tabs.query({ active: true, currentWindow: true }, (tabs) => {
      const tab = tabs[0];

      // chrome.scripting.executeScript({
      //   target: { tabId: tab.id },
      //   files: ['extractData.js']
      // });
      console.log("buttonClick egramswaraj inside"); 
      chrome.tabs.sendMessage(tab.id, { type: 'extractDataEgram', data: message.data });   
    });
  }
});
chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.type === 'buttonClick_pmfs') {
    // Send message to the content script for data extraction
    chrome.tabs.query({ active: true, currentWindow: true }, (tabs) => {
      const tab = tabs[0];

      // chrome.scripting.executeScript({
      //   target: { tabId: tab.id },
      //   files: ['extractData.js']
      // });
      console.log("buttonClick buttonClick_pmfs inside"); 
      chrome.tabs.sendMessage(tab.id, { type: 'extractDataPfms', data: message.data });   
    });
  }
});
chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  console.log("In background egram_voucher_extracted");
  if (message.type === 'egram_voucher_extracted') {
    // Send message to the content script for data pasting
    console.log("In background egram_voucher_extracted");
    chrome.tabs.query({ url: 'https://panchayatgateway.in/gram_sachiwalaya_gateway/*' }, (tabs) => {
      if (tabs.length > 0) {
        const tab = tabs[0];
        console.log("voucher get sending to our website LGD "+message.lgd_code);
        // Send the extracted data to the content script for pasting
        chrome.tabs.sendMessage(tab.id, { type: 'pasteVoucherEgram', data: message.data,site:'egram',lgd_code:message.lgd_code });
      } else {
        console.error('Destination website tab not found.');
      }
    });
  }
});
// Listen for extracted data from content script
chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.type === 'dataExtracted') {
    // Send message to the content script for data pasting
    chrome.tabs.query({ url: 'https://panchayatgateway.in/gram_sachiwalaya_gateway/Incidence/addIncidence2' }, (tabs) => {
      if (tabs.length > 0) {
        const tab = tabs[0];
        // chrome.scripting.executeScript({
        //   target: { tabId: tab.id },
        //   files: ['pasteData.js']
        // });
        console.log("dataExtracted");
        // Send the extracted data to the content script for pasting
        chrome.tabs.sendMessage(tab.id, { type: 'pasteData', data: message.data,lgd_code:message.lgd_code });
      } else {
        console.error('Destination website tab not found.');
      }
    });
  }
});
chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  console.log("In background pmfs_voucher_extracted ");
  if (message.type === 'pmfs_voucher_extracted') {
    // Send message to the content script for data pasting
    console.log("In background pmfs_voucher_extracted");
    chrome.tabs.query({ url: 'https://panchayatgateway.in/gram_sachiwalaya_gateway/*' }, (tabs) => {
      if (tabs.length > 0) {
        const tab = tabs[0];
        console.log("voucher get sending to our website gram_sachivlay pmfs "+message.lgd_code);
        // Send the extracted data to the content script for pasting
        chrome.tabs.sendMessage(tab.id, { type: 'pasteVoucherPmfs', data: message.data,site:'pmfs',lgd_code:message.lgd_code });
      } else {
        console.error('Destination website tab not found.');
      }
    });
  }
});
chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  console.log("In background pmfs_voucher_extract.html ");
  if (message.type === 'dataPfmsExtractExtracted') {
    // Send message to the content script for data pasting
    console.log("In background dataPfmsExtractExtracted lgd_code is "+message.lgdCode);
    chrome.tabs.query({ url: 'https://panchayatgateway.in/gram_sachiwalaya_gateway/Incidence/addIncidence2Sbm' }, (tabs) => {
      if (tabs.length > 0) {
        const tab = tabs[0];
        console.log("dataPfmsExtractExtracted get sending to our website");
        // Send the extracted data to the content script for pasting
        chrome.tabs.sendMessage(tab.id, { type: 'pasteVoucherPmfsExtract', data: message.data,scheme:message.scheme,lgd_code:message.lgdCode });
      } else {
        console.error('Destination website tab not found.');
      }
    });
  }
});

setInterval(function(){
    var gateway_found = false;// egram extract and paste data
    var geteway_found_egram_popup=false;// egram popup 
    var gateway_found_egram=false;// egrtam voucher
    var gateway_found_pfms_extract=false;// pfmd extarct and paste data
    var gateway_found_pfms_popup=false;// pfms popup
    var gateway_found_pfms=false;// pfms voucher
    
    function matchesSubUrlPatterns(url) {
      const subUrlPatterns = [
        'https://panchayatgateway.in/gram_sachiwalaya_gateway/Admin',
        'https://panchayatgateway.in/gram_sachiwalaya_gateway/Map',
        'https://panchayatgateway.in/gram_sachiwalaya_gateway/Location',
        'https://panchayatgateway.in/gram_sachiwalaya_gateway/Office',
        'https://panchayatgateway.in/gram_sachiwalaya_gateway/Employee',
        'https://panchayatgateway.in/gram_sachiwalaya_gateway/Incidence',
        'https://panchayatgateway.in/gram_sachiwalaya_gateway/Report'
      ];
      return subUrlPatterns.some(pattern => url.startsWith(pattern) && url.length > pattern.length);
    }

    chrome.tabs.query({ url: 'https://panchayatgateway.in/gram_sachiwalaya_gateway/*' }, (tabs) => {
      if (tabs.length > 0) {
        const matching = matchesSubUrlPatterns(tabs[0].url);
        console.log("url:",matching);
        if(matching){
          geteway_found_egram_popup = true;
          gateway_found_pfms_popup = true;
          gateway_found_egram = true;
          gateway_found_pfms = true;
        }
      }
    });

    chrome.tabs.query({ url: 'https://panchayatgateway.in/gram_sachiwalaya_gateway/Incidence/addIncidence2' }, (tabs) => {
      if (tabs.length > 0) {
        gateway_found = true;
      }
    });

    chrome.tabs.query({ url: 'https://panchayatgateway.in/gram_sachiwalaya_gateway/Incidence/addIncidence2Sbm' }, (tabs) => {
      if (tabs.length > 0) {
        gateway_found_pfms_extract = true;
      }
    });

    chrome.tabs.query({ url: 'https://egramswaraj.gov.in/*' }, (tabs) => {
      if (tabs.length > 0) {
        const tab = tabs[0];
        if( geteway_found_egram_popup ){
          console.log("gateway geteway_found_egram_popup");
          chrome.tabs.sendMessage(tab.id, { type: 'gateway_found_egram_popup', data: true });
        }else{
          console.log("gateway not geteway_found_egram_popup");
          chrome.tabs.sendMessage(tab.id, { type: 'gateway_found_egram_popup', data: false });
        }
      }
    });

    chrome.tabs.query({ url: 'https://pfms.nic.in/*' }, (tabs) => {
      if (tabs.length > 0) {
        const tab = tabs[0];
        if( gateway_found_pfms_popup ){
          console.log("gateway found for pop up pfms ");
          chrome.tabs.sendMessage(tab.id, { type: 'gateway_found_for_pmfs_popup', data: true });
        }else{
          console.log("gateway not found for pop up pmfs");
          chrome.tabs.sendMessage(tab.id, { type: 'gateway_found_for_pmfs_popup', data: false });
        }
      }
    });


    chrome.tabs.query({ url: 'https://egramswaraj.gov.in/AddPaymentVoucherOnline.htm' }, (tabs) => {
      if (tabs.length > 0) {
        const tab = tabs[0];
        if( gateway_found_egram ){
          console.log("gateway found for gateway_found_egram vouchercreat");
          chrome.tabs.sendMessage(tab.id, { type: 'gateway_found_egram', data: true });
        }else{
          console.log("gateway not found for gateway_found_egram vouchercreat");
          chrome.tabs.sendMessage(tab.id, { type: 'gateway_found_egram', data: false });
        }
      }
    });

    chrome.tabs.query({ url: 'https://pfms.nic.in/ImplementingAgency/FundsExpenditure/EditAgencyFundsExpenditures.aspx' }, (tabs) => {
      if (tabs.length > 0) {
        const tab = tabs[0];
        if( gateway_found_pfms ){
          console.log("gateway found for pmfs");
          chrome.tabs.sendMessage(tab.id, { type: 'gateway_found_pmfs', data: true });
        }else{
          console.log("gateway not found for pmfs");
          chrome.tabs.sendMessage(tab.id, { type: 'gateway_found_pmfs', data: false });
        }
      }
    });


    chrome.tabs.query({ url: 'https://egramswaraj.gov.in/signFtoNew.htm' }, (tabs) => {
      if (tabs.length > 0) {
        const tab = tabs[0];
        if( gateway_found ){
          console.log("gateway found");
          chrome.tabs.sendMessage(tab.id, { type: 'gateway_found', data: true });
        }else{
          console.log("gateway not found");
          chrome.tabs.sendMessage(tab.id, { type: 'gateway_found', data: false });
        }
      }
    });

    chrome.tabs.query({ url: 'https://pfms.nic.in/Agency/DscWinAppPaymentFile.aspx' }, (tabs) => {
      if (tabs.length > 0) {
        const tab = tabs[0];
        if( gateway_found_pfms_extract ){
          console.log("gateway found for gateway_found_pfms_extract");
          chrome.tabs.sendMessage(tab.id, { type: 'gateway_found_pmfs_extract', data: true });
        }else{
          console.log("gateway not found for gateway_found_pfms_extract");
          chrome.tabs.sendMessage(tab.id, { type: 'gateway_found_pmfs_extract', data: false });
        }
      }
    });

}, 2000);