function injectButton_pmfs(site, voucherNo,lgd_code) {
  // Create the button element
  const button = document.createElement('button');
  button.textContent = 'Click Here Voucher';
  button.id = 'PmfsVoucherButton';
  button.dataset.site = site; // Use dataset for custom attributes
  button.dataset.voucher = voucherNo; // Use dataset for custom attributes
  button.dataset.lgd_code=lgd_code;
  button.style.display = 'none'; // Initially hide the button

  // Append the button to the document body
  document.body.appendChild(button);

  // Add event listener to the button
  button.addEventListener('click', () => {
    console.log("Button clicked");
    console.log("Site:", button.dataset.site);
    console.log("Voucher Number:", button.dataset.voucher);
    // Add your code here to handle the button click event
  });

  return button;
}
function selectScehme( value, formIndex ){
  var optionSelected = null;
  var select = null;
  var intvlID = setInterval(function(){
    select = document.getElementById(`incidence_type_${formIndex}`);
    console.log(select.options.length);
    for (const option of select.options) {
        if (option.getAttribute('value') === value) {
            optionSelected = option;
        }
        clearInterval(intvlID);
    }
    
    if (optionSelected) {
        optionSelected.selected = true;
        select.dispatchEvent(new Event('change'));
        console.log(optionSelected);
    } else {
        console.log('Option not found.');
    }
  }, 100);
}



var voucherNo=null;
var button = null;
chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.type === 'pasteVoucherPmfs') {
    // Check if the button already exists
    if (!button && !voucherNo) {
      button = injectButton_pmfs(message.site, message.data,message.lgd_code);
      voucherNo=message.data;
      console.log("Message received in sendVoucherEgram "+message.data+" "+message.site+"lgd code is "+message.lgd_code);
      document.getElementById('PmfsVoucherButton').click();
    }
  }
});
var dataPastedPfms=false;
chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.type === 'pasteVoucherPmfsExtract' && !dataPastedPfms) {

    console.log("pasteVoucherPmfsExtract=",message.data);
    console.log("pasteVoucherPmfsExtract=",message.scheme);
    console.log("pasteVoucherPmfsExtract=",message.lgd_code);

    message.data.forEach((row,index) => {
      console.log(index);
      if(index==0){
        return
      }
      console.log("row clicked");
      document.getElementById('add_row').click();
    });

    message.data.forEach((row,index) => {
      const formIndex = index + 1;
      // const [scheme] = row["Voucher No"].split("-");
      selectScehme(message.scheme,formIndex);
      document.getElementById(`incidence_lat_${formIndex}`).value = row["Payment Advice No."];
      document.getElementById(`solve_in_sec_${formIndex}`).value = row["Amount"];
      document.getElementById(`sender_imei_${formIndex}`).value = row["Voucher No"];
      document.getElementById(`incidence_comment_${formIndex}`).value = row["Account No"];
      document.getElementById(`no_of_beneficiary_${formIndex}`).value = row["No Of Beneficiary"];
      document.getElementById(`come_from`).value = 'extension';
      document.getElementById(`lgd_code`).value = message.lgd_code;
    });
    dataPastedPfms=true;

  }else if(dataPastedPfms){
    console.log("Data already pasted..");
  }
});